<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.defaults.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class defaults {

//---- Defaults (Generic) Validation Checks

    function defaultsgen_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=lang("Error") ;
	
	if ($dt[company]=="")				$err=lang("Company Name Missing");
	if ($dt[contact]=="")				$err=lang("Company Contact Missing");
	if ($dt[phone] and !is_numeric($dt[phone]))	$err=lang("phone# must be numeric");
	if ($dt[fax] and !is_numeric($dt[fax]))		$err=lang("fax# must be numeric");
	if ($dt[email] and strpos($dt[email],'@')=='')	$err=lang("invalid email address");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$phpgw->db->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		$phpgw->db->next_record() ;
		if ($phpgw->db->Record['used_by']=="")
			$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=lang("Default Value Editting is being accessed by ").$phpgw->db->Record['used_by'];
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}
	
//---- Defaults (Ledger) Validation Checks

    function defaultslgr_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$db_type = $ckapi[hostsys][dbtype] ;
	$err=""; $error=lang("Error") ;
	
	if (strlen($dt[attrib1cap])>10)			$err=lang("Attribute1 caption descripton too long");
	if (substr_count($dt[attrib1cap]," ")>0)	$err=lang("Attribute1 caption should not contain space");
	if (strlen($dt[attrib2cap])>10)			$err=lang("Attribute2 caption description too long");
	if (substr_count($dt[attrib2cap]," ")>0)	$err=lang("Attribute2 caption should not contain space");
	if (strlen($dt[attrib3cap])>10)			$err=lang("Attribute3 caption description too long");
	if (substr_count($dt[attrib3cap]," ")>0)	$err=lang("Attribute3 caption should not contain space");
	$table = array(0,$dt[attrib1tbl], $dt[attrib2tbl], $dt[attrib3tbl]) ;
	$sdesc = array(0,$dt[attrib1sdesc],$dt[attrib2sdesc],$dt[attrib3sdesc]) ;
	$ldesc = array(0,$dt[attrib1ldesc],$dt[attrib2ldesc],$dt[attrib3ldesc]) ;
	for ($i=1; $i<4; $i++ ) {
		$tblid = $tblsdesc = $tblldesc = False ;
		$tbl = $table[$i] ;
		$sd  = $sdesc[$i] ;
		$ld  = $ldesc[$i] ;
		$sql = "select a.attname, format_type(a.atttypid,a.atttypmod) from pg_class c,pg_attribute a " ;
		$sql.= "where c.relname='$tbl' and a.attnum>0 and a.attrelid=c.oid" ;
		if ($db_type=="mysql")		$sql = "describe $tbl" ;
		$phpgw->db->query($sql);
		While ($phpgw->db->next_record()) {
			$fldname = $phpgw->db->Record[0] ;
			$fldtype = $phpgw->db->Record[1] ;
			if ($fldname=="id" and substr($fldtype,0,3)=='int')	$tblid = True ;
			if ($fldname==$sd) 					$tblsdesc = True ;
			if ($fldname==$ld)					$tblldesc = True ;
			}
		$attablei = "[".lang("Attrib table")." $i]" ;
		if (!$tblid)	$err=$attablei.lang("must have id field [type int(eger)]");
		if (!$tblsdesc)	$err=$attablei.lang("does not have field ")."[$sd]" ;
		if (!$tblldesc)	$err=$attablei.lang("does not have field ")."[$ld]" ;
		}
	if (input2date($dt[yearend])=="")		$err=lang("Invalid Year End Date");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$phpgw->db->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		$phpgw->db->next_record() ;	
		if ($phpgw->db->Record['used_by']=="")
			$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=lang("Default Value Editting is being accessed by ").$phpgw->db->Record['used_by'];
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}
	
//---- Defaults (AP/AR/PO/SO/Quotation) Validation Checks

    function defaultsapr_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=lang("Error") ;

	if (strlen($dt[aptax1cap])>10)			$err=lang("AP/PO Primary Tax caption descripton too long");
	if (substr_count($dt[aptax1cap]," ")>0)		$err=lang("AP/PO Primary Tax caption should not contain space");
	if (strlen($dt[aptax2cap])>10)			$err=lang("AP/PO Secondary Tax caption descripton too long");
	if (substr_count($dt[aptax2cap]," ")>0)		$err=lang("AP/PO Secondary Tax caption should not contain space");
	if (strlen($dt[artax1cap])>10)			$err=lang("AR/SO/Quotation Primary Tax caption descripton too long");
	if (substr_count($dt[artax1cap]," ")>0)		$err=lang("AR/SO/Quotation Primary Tax caption should not contain space");
	if (strlen($dt[artax2cap])>10)			$err=lang("AR/SO/Quotation Secondary Tax caption descripton too long");
	if (substr_count($dt[artax2cap]," ")>0)		$err=lang("AR/SO/Quotation Secondary Tax caption should not contain space");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$phpgw->db->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		$phpgw->db->next_record() ;	
		if ($phpgw->db->Record['used_by']=="")
			$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=lang("Default Value Editting is being accessed by ").$phpgw->db->Record['used_by'];
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Defaults (Point of Sale) Validation Checks

    function defaultspos_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=lang("Error") ;

	if (strlen($dt[postax1cap])>10)			$err=lang("POS Primary Tax caption descripton too long");
	if (substr_count($dt[postax1cap]," ")>0)	$err=lang("POS Primary Tax caption should not contain space");
	if (strlen($dt[postax2cap])>10)			$err=lang("POS Secondary Tax caption descripton too long");
	if (substr_count($dt[postax2cap]," ")>0)	$err=lang("POS Secondary Tax caption should not contain space");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$phpgw->db->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		$phpgw->db->next_record() ;	
		if ($phpgw->db->Record['used_by']=="")
			$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=lang("Default Value Editting is being accessed by ").$phpgw->db->Record['used_by'];
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Defaults (HR/SSS/Payroll) Validation Checks

    function defaultshrp_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=lang("Error") ;

	if ($dt[mndfactor]=="")				$err=lang("Daily Salary Imputation (monthly) divisor Missing");
	if ($dt[smdfactor]=="")				$err=lang("Daily Salary Imputation (semi-monthly) divisor Missing");
	if ($dt[wkdfactor]=="")				$err=lang("Daily Salary Imputation (weekly) divisor Missing");
	if ($dt[mnhfactor]=="")				$err=lang("Hourly Salary Imputation (monthly) divisor Missing");
	if ($dt[smhfactor]=="")				$err=lang("Hourly Salary Imputation (semi-monthly) divisor Missing");
	if ($dt[wkhfactor]=="")				$err=lang("Hourly Salary Imputation (weekly) divisor Missing");
	if ($dt[dyhfactor]=="")				$err=lang("Hourly Salary Imputation (daily) divisor Missing");
	if (!is_numeric($dt[mndfactor]) or strpos($dt[mndfactor],".")<>"")
							$err=lang("Daily Salary Imputation (monthly) divisor must be integer");
	if (!is_numeric($dt[smdfactor]) or strpos($dt[smdfactor],".")<>"")
							$err=lang("Daily Salary Imputation (semi-monthly) divisor must be integer");
	if (!is_numeric($dt[wkdfactor]))		$err=lang("Daily Salary Imputation (weekly) divisor must be numeric");
	if (!is_numeric($dt[mnhfactor]) or strpos($dt[mnhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (monthly) divisor must be integer");
	if (!is_numeric($dt[smhfactor]) or strpos($dt[smhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (semi-monthly) divisor must be integer");
	if (!is_numeric($dt[wkhfactor]) or strpos($dt[wkhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (weekly) divisor must be integer");
	if (!is_numeric($dt[dyhfactor]) or strpos($dt[dyhfactor],".")<>"")
							$err=lang("Hourly Salary Imputation (daily) divisor must be integer");
	if ($err=="") {
		$user = $ckapi[hostsys][username];
		$phpgw->db->query("SELECT * FROM ${pre}resourcelock WHERE resource='defaultsedit'");
		$phpgw->db->next_record() ;	
		if ($phpgw->db->Record['used_by']=="")
			$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='defaultsedit'");
		  else	$err=lang("Default Value Editting is being accessed by ").$phpgw->db->Record['used_by'];
		}

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Defaults (Generic) Detail

    function defaultsgen_write() {
	global $ckapi,$phpgw ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_company',lang('Company Name'));
	$t->set_var('lang_address',lang('Address'));
	$t->set_var('lang_contact',lang('Contact'));
	$t->set_var('lang_phone',lang('Phone'));
	$t->set_var('lang_fax',lang('Fax'));
	$t->set_var('lang_email',lang('E-Mail'));
	$t->set_var('lang_weightunit',lang('Unit Weight'));
	$t->set_var('lang_version',lang('Software Version'));

	$t->set_var('id',$dt[id]);
	$t->set_var('company',$dt[company]);
	$t->set_var('addr1',$dt[addr1]);
	$t->set_var('addr2',$dt[addr2]);
	$t->set_var('addr3',$dt[addr3]);
	$t->set_var('addr4',$dt[addr4]);
	$t->set_var('contact',$dt[contact]);
	$t->set_var('phone',$dt[phone]);
	$t->set_var('fax',$dt[fax]);
	$t->set_var('email',$dt[email]);
	$t->set_var('nativecurr',$dt[nativecurr]);
	$t->set_var('weightunit',$dt[weightunit]);
	$t->set_var('yearend',$dt[yearend]);
	$t->set_var('version',$dt[version]);
	
	$t->parse('out','report',True);
	}
	
//---- Write Defaults (Ledger) Detail

    function defaultslgr_write() {
	global $ckapi,$phpgw ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$yes=lang('Yes'); $no=lang('No'); 
	$yesno_sl = "<OPTION value='yes'>$yes</option><OPTION value='no'>$no</option>" ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_attribdef',lang('Attribute'));
	$t->set_var('lang_attribcap',lang('Caption<br>Description'));
	$t->set_var('lang_attribtbl',lang('Table Name'));
	$t->set_var('lang_attribsdesc',lang('Short Desc Field Name'));
	$t->set_var('lang_attribldesc',lang('Long Desc Field Name'));
	$t->set_var('lang_attribtblmn',lang('Allow Table Maintenance<br>in Ledger module'));
	$t->set_var('lang_attribcnval',lang('Keep Value Constant<br>within a single journal'));
	$t->set_var('lang_attrib1',lang('Attribute1'));
	$t->set_var('lang_attrib2',lang('Attribute2'));
	$t->set_var('lang_attrib3',lang('Attribute3'));
	
	$t->set_var('lang_nativecurr',lang('Ledger Currency'));
	$t->set_var('lang_yearend',lang('Year End Date'));
	$t->set_var('lang_inc',lang('Income A/C'));
	$t->set_var('lang_exp',lang('Expense A/C'));
	$t->set_var('lang_inv',lang('Inventory A/C'));

	$t->set_var('id',$dt[id]);
	$t->set_var('attrib1cap',$dt[attrib1cap]);
	$t->set_var('attrib2cap',$dt[attrib2cap]);
	$t->set_var('attrib3cap',$dt[attrib3cap]);
	$t->set_var('attrib1tbl_selectlist',table_selectlist("",$dt[attrib1tbl]));
	$t->set_var('attrib2tbl_selectlist',table_selectlist("",$dt[attrib2tbl]));
	$t->set_var('attrib3tbl_selectlist',table_selectlist("",$dt[attrib3tbl]));
	$t->set_var('attrib1sdesc',$dt[attrib1sdesc]);
	$t->set_var('attrib2sdesc',$dt[attrib2sdesc]);
	$t->set_var('attrib3sdesc',$dt[attrib3sdesc]);
	$t->set_var('attrib1ldesc',$dt[attrib1ldesc]);
	$t->set_var('attrib2ldesc',$dt[attrib2ldesc]);
	$t->set_var('attrib3ldesc',$dt[attrib3ldesc]);
	$tblmn_sl = str_replace("'$dt[attrib1tblmn]'","'$dt[attrib1tblmn]'"." selected",$yesno_sl) ;
	$t->set_var('attrib1tblmn_selectlist',$tblmn_sl);
	$tblmn_sl = str_replace("'$dt[attrib2tblmn]'","'$dt[attrib2tblmn]'"." selected",$yesno_sl) ;
	$t->set_var('attrib2tblmn_selectlist',$tblmn_sl);
	$tblmn_sl = str_replace("'$dt[attrib3tblmn]'","'$dt[attrib3tblmn]'"." selected",$yesno_sl) ;
	$t->set_var('attrib3tblmn_selectlist',$tblmn_sl);
	$cnval_sl = str_replace("'$dt[attrib1cnval]'","'$dt[attrib1cnval]'"." selected",$yesno_sl) ;
	$t->set_var('attrib1cnval_selectlist',$cnval_sl);
	$cnval_sl = str_replace("'$dt[attrib2cnval]'","'$dt[attrib2cnval]'"." selected",$yesno_sl) ;
	$t->set_var('attrib2cnval_selectlist',$cnval_sl);
	$cnval_sl = str_replace("'$dt[attrib3cnval]'","'$dt[attrib3cnval]'"." selected",$yesno_sl) ;
	$t->set_var('attrib3cnval_selectlist',$cnval_sl);

	$t->set_var('nativecurr_selectlist',currency_selectlist("",$dt[nativecurr]));
	$t->set_var('yearend',$dt[yearend]);
	$t->set_var('inc_selectlist',account_selectlist("WHERE link like '%AR_amount%'",$dt[income_accno_id]));
	$t->set_var('exp_selectlist',account_selectlist("WHERE link like '%AP_amount%'",$dt[expense_accno_id]));
	$t->set_var('inv_selectlist',account_selectlist("WHERE link like '%IC:%' or link like '%IC'",$dt[inventory_accno_id]));

	$t->parse('out','report',True);
	}
	
//---- Write Defaults (AP/AR/PO/SO/Quotation) Detail

    function defaultsapr_write() {
	global $ckapi,$phpgw ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$irate = lang('apply item tax rate') ;
	$crate = lang('apply customer rate') ;
	$vrate = lang('apply vendor rate') ;
	$srate = lang('apply my std rate') ;
	$zrate = lang('tax rate = zero') ;
	$mrate = lang('manual tax input') ;
	$aptax_pref_slist = "<OPTION value=''></OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='i'>$irate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='v'>$vrate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='z'>$zrate</OPTION>" ;
	$aptax_pref_slist.= "<OPTION value='m'>$mrate</OPTION>" ;
	$artax_pref_slist = "<OPTION value=''></OPTION>" ;
	$artax_pref_slist.= "<OPTION value='i'>$irate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='c'>$crate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='z'>$zrate</OPTION>" ;
	$artax_pref_slist.= "<OPTION value='m'>$mrate</OPTION>" ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_aptax',lang('AP/PO Tax'));
	$t->set_var('lang_aptax1',lang('Primary'));
	$t->set_var('lang_aptax2',lang('Secondary'));
	$t->set_var('lang_aptaxcap',lang('Caption Description'));
	$langits = lang('Initial Setting of Tax Rate Drop Down Select List') ;
	$note = lang('(my std rate = my standard rate as a customer)') ;
	$t->set_var('lang_aptaxpref',"$langits:  $note");
	$t->set_var('lang_artax',lang('AR/SO/Quotation Tax'));
	$t->set_var('lang_artax1',lang('Primary'));
	$t->set_var('lang_artax2',lang('Secondary'));
	$t->set_var('lang_artaxcap',lang('Caption Description'));
	$note = lang('(my std rate = my standard rate as a vendor)') ;
	$t->set_var('lang_artaxpref',"$langits:  $note");
	$t->set_var('lang_remark',lang('Remarks'));
	$t->set_var('lang_invoice',lang('Invoice'));
	$t->set_var('lang_reminder',lang('Reminder'));
	$t->set_var('lang_po',lang('PO'));
	$t->set_var('lang_quo',lang('Quotation'));

	$t->set_var('id',$dt[id]);
	$t->set_var('aptax1cap',$dt[aptax1cap]);
	$t->set_var('aptax2cap',$dt[aptax2cap]);
	$tax1_sl = str_replace("'$dt[aptax1pref]'","'$dt[aptax1pref]'"." selected",$aptax_pref_slist) ;
	$t->set_var('aptax1pref_selectlist',$tax1_sl);
	$tax2_sl = str_replace("'$dt[aptax2pref]'","'$dt[aptax2pref]'"." selected",$aptax_pref_slist) ;
	$t->set_var('aptax2pref_selectlist',$tax2_sl);
	$t->set_var('artax1cap',$dt[artax1cap]);
	$t->set_var('artax2cap',$dt[artax2cap]);
	$tax1_sl = str_replace("'$dt[artax1pref]'","'$dt[artax1pref]'"." selected",$artax_pref_slist) ;
	$t->set_var('artax1pref_selectlist',$tax1_sl);
	$tax2_sl = str_replace("'$dt[artax2pref]'","'$dt[artax2pref]'"." selected",$artax_pref_slist) ;
	$t->set_var('artax2pref_selectlist',$tax2_sl);
	$t->set_var('invrmk_selectlist',remark_selectlist("",$dt[inv_rmkid]));
	$t->set_var('rmdrmk_selectlist',remark_selectlist("",$dt[rmd_rmkid]));
	$t->set_var('pormk_selectlist',remark_selectlist("",$dt[po_rmkid]));
	$t->set_var('quormk_selectlist',remark_selectlist("",$dt[quo_rmkid]));

	$t->parse('out','report',True);
	}
	
//---- Write Defaults (Point of Sale) Detail

    function defaultspos_write() {
	global $ckapi,$phpgw ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$irate = lang('apply item tax rate') ;
	$srate = lang('apply my std rate') ;
	$postax_pref_slist = "<OPTION value='i'>$irate</OPTION>" ;
	$postax_pref_slist.= "<OPTION value='s'>$srate</OPTION>" ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_postax',lang('POS Tax'));
	$t->set_var('lang_postax1',lang('Primary'));
	$t->set_var('lang_postax2',lang('Secondary'));
	$t->set_var('lang_postaxcap',lang('Caption Description'));
	$langtx = lang('What Type of Tax Rate to apply to Cash Sale') ;
	$note = lang('(my std rate = my standard rate as a vendor)') ;
	$t->set_var('lang_postaxpref',"$langtx:  $note");
	$t->set_var('lang_remark',lang('Remarks'));
	$t->set_var('lang_sm',lang('Sales Memo'));

	$t->set_var('id',$dt[id]);
	$t->set_var('postax1cap',$dt[postax1cap]);
	$t->set_var('postax2cap',$dt[postax2cap]);
	$tax1_sl = str_replace("'$dt[postax1pref]'","'$dt[postax1pref]'"." selected",$postax_pref_slist) ;
	$t->set_var('postax1pref_selectlist',$tax1_sl);
	$tax2_sl = str_replace("'$dt[postax2pref]'","'$dt[postax2pref]'"." selected",$postax_pref_slist) ;
	$t->set_var('postax2pref_selectlist',$tax2_sl);
	$t->set_var('smrmk_selectlist',remark_selectlist("",$dt[sm_rmkid]));
	
	$t->parse('out','report',True);
	}

//---- Write Defaults (PHR/SSS/Payroll) Detail

    function defaultshrp_write() {
	global $ckapi,$phpgw ;

	$t = &$ckapi[objects][template] ;
	$dt = &$ckapi[params_post][dt] ;

	$yes=lang('Yes'); $no=lang('No'); 
	$yesno_sl = "<OPTION value='yes'>$yes</option><OPTION value='no'>$no</option>" ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color_a',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('tr_color_b',$ckapi[hostsys][tr_color1]) ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_hr',lang('Human Resources'));
	$t->set_var('lang_photo',lang('Photo'));
	$t->set_var('lang_address',lang('Address'));
	$t->set_var('lang_phone',lang('Phone'));
	$t->set_var('lang_email',lang('E-Mail'));
	$t->set_var('lang_ec',lang('Emergency Contact'));
	$t->set_var('lang_update',lang('Staff allowed to update their personal info regarding this data ?'));

	$t->set_var('lang_pyr',lang('Payroll'));
	$t->set_var('lang_mn',lang('Monthly'));
	$t->set_var('lang_smn',lang('Semi-monthly'));
	$t->set_var('lang_wk',lang('Weekly'));
	$t->set_var('lang_dy',lang('Daily'));
	$t->set_var('lang_salary',lang('Salary divided by'));
	$t->set_var('lang_daypay',lang('Imputed Daily Salary calculated by:'));
	$t->set_var('lang_hourpay',lang('Imputed Hourly Salary calculated by:'));

	$t->set_var('id',$dt[id]);
	$photoyn_sl = str_replace("'$dt[photoyn]'","'$dt[photoyn]'"." selected",$yesno_sl) ;
	$t->set_var('photoyn_selectlist',$photoyn_sl);
	$addressyn_sl = str_replace("'$dt[addressyn]'","'$dt[addressyn]'"." selected",$yesno_sl) ;
	$t->set_var('addressyn_selectlist',$addressyn_sl);
	$phoneyn_sl = str_replace("'$dt[phoneyn]'","'$dt[phoneyn]'"." selected",$yesno_sl) ;
	$t->set_var('phoneyn_selectlist',$phoneyn_sl);
	$emailyn_sl = str_replace("'$dt[emailyn]'","'$dt[emailyn]'"." selected",$yesno_sl) ;
	$t->set_var('emailyn_selectlist',$emailyn_sl);
	$ecyn_sl = str_replace("'$dt[ecyn]'","'$dt[ecyn]'"." selected",$yesno_sl) ;
	$t->set_var('ecyn_selectlist',$ecyn_sl);

	$t->set_var('mndfactor',$dt[mndfactor]);
	$t->set_var('smdfactor',$dt[smdfactor]);
	$t->set_var('wkdfactor',$dt[wkdfactor]);
	$t->set_var('mnhfactor',$dt[mnhfactor]);
	$t->set_var('smhfactor',$dt[smhfactor]);
	$t->set_var('wkhfactor',$dt[wkhfactor]);
	$t->set_var('dyhfactor',$dt[dyhfactor]);

	$t->parse('out','report',True);
	}

//---- Default Value Post (posting data to db table)

    function post() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$tranobj = &$ckapi[objects][tranobj] ;

	$db_type = $ckapi[hostsys][dbtype] ;
	$table = "${pre}defaults";
	$id = ($dt[id]=="") ? 0 : $dt[id] ;
	$ip = ($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$user = $ckapi[hostsys][username];
	$now = mktime() ;
	$iptime = "$ip=$now=$script=$id" ;

	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
	$sql.= "VALUES ('$id','$app','$script','$ip','$user','$op','$now','$iptime')" ;
	$phpgw->db->query($sql);
	$phpgw->db->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
	$phpgw->db->next_record();
	$logid = $phpgw->db->f('id');

	switch ($tran) :
		case "defaultsgen" :
			$sql = "UPDATE $table SET company='$dt[company]',addr1='$dt[addr1]',addr2='$dt[addr2]'," ;
			$sql.= "addr3='$dt[addr3]',addr4='$dt[addr4]',contact='$dt[contact]',phone='$dt[phone]',";
			$sql.= "email='$dt[email]',fax='$dt[fax]',weightunit='$dt[weightunit]',version='$dt[version]' ";
			$phpgw->db->query($sql);
			$sql = "SELECT id,company,addr1,addr2,addr3,addr4,contact,phone,email,fax,weightunit,version " ;
			$sql.= "FROM $table ";
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$headerarr[$table] = $phpgw->db->Record;
			$header = addslashes(serialize($headerarr));
			$phpgw->db->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = lang("Old") ;
			$lang_tran = lang("Generic Default Values") ;
			$actioned = lang("updated") ;
			break ;
		case "defaultslgr" :
			$sql = "UPDATE $table SET " ;
			$sql.= "attrib1cap='$dt[attrib1cap]',attrib2cap='$dt[attrib2cap]',attrib3cap='$dt[attrib3cap]',";
			$sql.= "attrib1tbl='$dt[attrib1tbl]',attrib2tbl='$dt[attrib2tbl]',attrib3tbl='$dt[attrib3tbl]',";
			$sql.= "attrib1sdesc='$dt[attrib1sdesc]',attrib2sdesc='$dt[attrib2sdesc]',attrib3sdesc='$dt[attrib3sdesc]',";
			$sql.= "attrib1ldesc='$dt[attrib1ldesc]',attrib2ldesc='$dt[attrib2ldesc]',attrib3ldesc='$dt[attrib3ldesc]',";
			$sql.= "attrib1tblmn='$dt[attrib1tblmn]',attrib2tblmn='$dt[attrib2tblmn]',attrib3tblmn='$dt[attrib3tblmn]',";
			$sql.= "attrib1cnval='$dt[attrib1cnval]',attrib2cnval='$dt[attrib2cnval]',attrib3cnval='$dt[attrib3cnval]',";
			$sql.= "nativecurr='$dt[nativecurr]',yearend='$dt[yearend]',income_accno_id='$dt[income_accno_id]'," ;
			$sql.= "expense_accno_id='$dt[expense_accno_id]',inventory_accno_id='$dt[inventory_accno_id]'";
			$phpgw->db->query($sql);
			$sql = "SELECT id,attrib1cap,attrib2cap,attrib3cap,attrib1tbl,attrib2tbl,attrib3tbl," ;
			$sql.= "attrib1sdesc,attrib2sdesc,attrib3sdesc,attrib1ldesc,attrib2ldesc,attrib3ldesc," ;
			$sql.= "attrib1tblmn,attrib2tblmn,attrib3tblmn,attrib1cnval,attrib2cnval,attrib3cnval," ;
			$sql.= "nativecurr,yearend,income_accno_id,expense_accno_id,inventory_accno_id " ;
			$sql.= "FROM $table ";
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$headerarr[$table] = $phpgw->db->Record;
			$header = addslashes(serialize($headerarr));
			$phpgw->db->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = lang("Old") ;
			$lang_tran = lang("Ledger Default Values") ;
			$actioned = lang("updated") ;
			break ;
		case "defaultsapr" :
			$sql = "UPDATE $table SET " ;
			$sql.= "aptax1cap='$dt[aptax1cap]',aptax2cap='$dt[aptax2cap]'," ;
			$sql.= "aptax1pref='$dt[aptax1pref]',aptax2pref='$dt[aptax2pref]'," ;
			$sql.= "artax1cap='$dt[artax1cap]',artax2cap='$dt[artax2cap]'," ;
			$sql.= "artax1pref='$dt[artax1pref]',artax2pref='$dt[artax2pref]'," ;
			$sql.= "inv_rmkid='$dt[inv_rmkid]',rmd_rmkid='$dt[rmd_rmkid]',";
			$sql.= "po_rmkid='$dt[po_rmkid]',quo_rmkid='$dt[quo_rmkid]' ";
			$phpgw->db->query($sql);
			$sql = "SELECT id,aptax1cap,aptax2cap,aptax1pref,aptax2pref," ;
			$sql.= "artax1cap,artax2cap,artax1pref,artax2pref," ;
			$sql.= "inv_rmkid,rmd_rmkid,po_rmkid,quo_rmkid " ;
			$sql.= "FROM $table ";
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$headerarr[$table] = $phpgw->db->Record;
			$header = addslashes(serialize($headerarr));
			$phpgw->db->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = lang("Old") ;
			$lang_tran = lang("AP/AR/PO/SO/Quotation Default Values") ;
			$actioned = lang("updated") ;
			break ;
		case "defaultspos" :
			$sql = "UPDATE $table SET " ;
			$sql.= "postax1cap='$dt[postax1cap]',postax2cap='$dt[postax2cap]'," ;
			$sql.= "postax1pref='$dt[postax1pref]',postax2pref='$dt[postax2pref]'," ;
			$sql.= "sm_rmkid='$dt[sm_rmkid]' ";
			$phpgw->db->query($sql);
			$sql = "SELECT id,postax1cap,postax2cap,postax1pref,postax2pref,sm_rmkid " ;
			$sql.= "FROM $table ";
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$headerarr[$table] = $phpgw->db->Record;
			$header = addslashes(serialize($headerarr));
			$phpgw->db->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = lang("Old") ;
			$lang_tran = lang("Point of Sale Default Values") ;
			$actioned = lang("updated") ;
			break ;
		case "defaultshrp" :
			$sql = "UPDATE $table SET " ;
			$sql.= "photoyn='$dt[photoyn]',addressyn='$dt[addressyn]',";
			$sql.= "phoneyn='$dt[phoneyn]',emailyn='$dt[emailyn]',ecyn='$dt[ecyn]'," ;
			$sql.= "mndfactor='$dt[mndfactor]',smdfactor='$dt[smdfactor]'," ;
			$sql.= "wkdfactor='$dt[wkdfactor]',mnhfactor='$dt[mnhfactor]'," ;
			$sql.= "smhfactor='$dt[smhfactor]',wkhfactor='$dt[wkhfactor]'," ;
			$sql.= "dyhfactor='$dt[dyhfactor]'" ;
			$phpgw->db->query($sql);
			$sql = "SELECT id,photoyn,addressyn,phoneyn,emailyn,ecyn," ;
			$sql.= "mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
			$sql.= "FROM $table ";
			$phpgw->db->query($sql);
			$phpgw->db->next_record();
			$headerarr[$table] = $phpgw->db->Record;
			$header = addslashes(serialize($headerarr));
			$phpgw->db->query("UPDATE ${pre}log SET header='$header' WHERE id='$logid'");
			$type = lang("Old") ;
			$lang_tran = lang("HR/SSS/Payroll Default Values") ;
			$actioned = lang("updated") ;
			break ;
		endswitch ;

	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='defaultsedit'");

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	
	$message = "$type $lang_tran [id#$id] $actioned" ; 
	$t->set_var("message","<b>$message.  $reminder.</b>");
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	}

    }

?>
