<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.attend.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class attend {

//---- Attendance List SQL Formation

    function attend_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	if (!$order) {$order = "name,transdate,time" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql =  "SELECT b.name,d.description as dept,transdate,time,a.type," ;
	$sql.=	"c.description as reason, a.id as id " ;
	$sql.=  "FROM ${pre}attendance a,${pre}employee b,${pre}hrcode c,${pre}department d ";
	$sql.=  "WHERE 1=1 $where and empid=b.id and b.dept=d.id and a.type=c.type and a.reason=c.name " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- Attendance Read

    function attend_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	global $phpgw ;

	$phpgw->db->query("SELECT * from $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[signin] = $dt[signout] = $dt[reason] ;
	if (!is_array($uniqueflds))	return $dt ;
	  else  {foreach ($uniqueflds as $key => $val)	$dt["old$val"]=$dt["$val"];	return $dt ;}
	}

//---- attend Detail Validation Checks

    function attend_validate() {
	global $ckapi,$phpgw ;

//	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$err=""; $error = lang("Error") ;
	$time = $dt[time] ;
	$hr = substr($time,0,2) ;
	$t2 = substr($time,2,1) ;
	$mn = substr($time,3,2) ;
	$t5 = substr($time,5,1) ;
	$sc = substr($time,6,2) ;
	if (input2date($dt[transdate])=="")		$err=lang("Invalid Date") ;
	if ($hr<0 or $hr>23)				$err=lang("Invalid Time") ;
	if ($mn<0 or $mn>59)				$err=lang("Invalid Time") ;
	if ($sc<0 or $sc>59)				$err=lang("Invalid Time") ;
	if ($t2<>":" or $t5<>":")			$err=lang("Invalid Time Format") ;
	if ($dt[type]=="$lang_si" and $dt[signin]=='')	$err=lang("Sign in Reason Missing") ;
	if ($dt[type]=="$lang_so" and $dt[signout]=='')	$err=lang("Sign out Reason Missing") ;
	if ($dt[signin]<>'' and $dt[signout]<>'')	$err=lang("Both Sign In & Out Reasons are active") ;
	if ($err)					$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Attendance Detail

    function attend_write() {
	global $ckapi,$phpgw ;

	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$blankopt = "<OPTION value=''></OPTION>" ;
	$type_sl = "<OPTION value='$lang_si'>$lang_si</OPTION>" ;
	$type_sl.= "<OPTION value='$lang_so'>$lang_so</OPTION>" ;
	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_time',lang('Time'));
	$t->set_var('lang_type',lang('Type'));
	$t->set_var('lang_signin',lang('Sign In Reason'));
	$t->set_var('lang_signout',lang('Sign Out Reason'));

	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('empid_selectlist',employee_selectlist($where,$dt[empid])) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('time',$dt[time]);
	$t->set_var('type_selectlist',str_replace("'$dt[type]'","'$dt[type]' selected",$type_sl));

	$signin_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_si'",'','long') ;
	$signin_sl = str_replace("'$dt[signin]'","'$dt[signin]' selected",$signin_sl) ;
	$t->set_var('signin_selectlist',$signin_sl);
	$signout_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_so'",'','long') ;
	$signout_sl = str_replace("'$dt[signout]'","'$dt[signout]' selected",$signout_sl) ;
	$t->set_var('signout_selectlist',$signout_sl);

	$t->parse('out','report',True);
	}

//---- Attendance Post Initialisation

    function attend_post_init() {
	global $ckapi ;

	$dt = $ckapi[params_post][dt] ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$ckapi[params_post][dt][reason] = ($dt[type]=="$lang_si") ? $dt[signin] : $dt[signout] ;
	}

    }

?>
