<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.gr.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class gr {


//---- Goods Receipt List SQL Formation

    function gr_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$sql =  "SELECT transdate,name as vendor,source,description,a.id as id " ;
	$sql.=	"FROM ${pre}il a, ${pre}vendor b " ;
	$sql.=	"WHERE substring(source,1,2)='GR' $where and a.to_from=b.id order by ".$order." ".$sort;
	return $sql ;
	}

//---- Goods Receipt Read

    function gr_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * from ${pre}il where id=$id");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[lastvendor] = $dt[vendor] = $phpgw->db->f('to_from') ;

	$phpgw->db->query("SELECT * from ${pre}inv_trans WHERE trans_id='$id'");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['po'.$i]	=	$phpgw->db->f('order_id') ;
		$dt['part'.$i]	=	$phpgw->db->f('parts_id') ;
		$dt['qty'.$i]	=	$phpgw->db->f('qty') ;
		}
	if ($ckapi[params_post][op]=="view")	$dt[controltot] = lang("N/A") ;
	return $dt ;
	}

//---- Goods Receipt Add Initialisation

    function gr_add_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt['po1'] = $dt['part1'] = $dt['qty1'] = "";
	}

//---- Goods Receipt Validation Checks

    function gr_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$err=""; $error=lang("Error") ;
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")				$err=lang("Invalid Goods Receipt Date");
	if ($dt["description"]=="")		$err=lang("GR Description Missing");
	$id = $dt[id] ;
	$vendor = $dt[vendor] ;
	$lastvendor = $dt[lastvendor] ;
	$totalqty = 0 ;
	For ($i=1;isset($dt['part'.$i]);$i++) {
		$qty = $dt['qty'.$i] ;
		$po  = $dt['po'.$i] ;
		$part= $dt['part'.$i] ;
		$row = lang("Row") ;
		$rowi = "[$row $i]" ;
		if ($qty and !is_numeric($qty)) $err=$rowi.lang("Invalid Qty, must be numeric");
		if ($qty==0)			$err=$rowi.lang("Invalid Qty, must be non-zero");
		if ($po=="")			$err=$rowi.lang("Invalid PO") ;
		  else	{
			$phpgw->db->query("SELECT vendor from ${pre}po where id='$po' and vendor='$vendor'") ;
			if (!$phpgw->db->next_record())	$err=$rowi.lang("PO belongs to another vendor");
			$sql = "SELECT qty from ${pre}oitem where trans_id='$po' and itemid='$part'" ;
			$phpgw->db->query($sql) ;
			if ($phpgw->db->next_record()) {
				$poqty = $phpgw->db->f('qty') ;
				$sql = "SELECT sum(qty) as q from ${pre}inv_trans " ;
				$sql.= "WHERE order_id='$po' and parts_id='$part'";
				if ($op=='edit')		$sql .= " and trans_id<>'$id'" ;
				$phpgw->db->query($sql) ;
				$phpgw->db->next_record() ;
				$q = $phpgw->db->f('q') ;
				if ($qty>($poqty-$q))		$err=$rowi.lang("Receiving Qty > O/S PO qty");
				}
			   else					$err=$rowi.lang("PO does not have this part");
			}
		For ($j=1;isset($dt['part'.$j]);$j++) {
			$rowj = "[$row $j]" ;
			if ($dt['part'.$i]==$dt['part'.$j] and $dt['po'.$i]==$dt['po'.$j] and $i<>$j)
					$err=$rowi.$rowj.lang("Rows with same PO&Part#");
			}
		$totalqty += $dt['qty'.$i] ;
		}
	if ($totalqty<>$dt[controltot])		$err=lang("Qty Total <> Inputted Control Total");
	if ($vendor<>$lastvendor and $lastvendor<>"")
		$err=lang("Vendor changed; new PO list loaded; pls re-check all input") ;
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Goods Receipt Header

    function gr_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_vendor',lang('Vendor :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('vendor_selectlist',vendor_selectlist('',$dt[vendor])) ;
	$t->set_var('lastvendor',$dt[vendor]) ;
	$t->set_var('source',$dt[source]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Write Goods Receipt Detail

    function gr_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_parts',lang('Part Number -- Description -- ID'));
	$t->set_var('lang_po',lang('(Received against) PO Number -- ID'));
	$t->set_var('lang_qty',lang('Quantity'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$part_list = part_selectlist("",'') ;
	if ($dt[vendor]=="")	$dt[vendor]=0 ;
	$po_list = po_selectlist(" WHERE vendor='$dt[vendor]' ",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($dt['part'.$i]);$i++) {
		if ($i<>$rowno) {
			$po	=	$dt['po'.$i];
			$part	=	$dt['part'.$i] ;
			$qty	=	$dt['qty'.$i];
			$j = ($delete and $i>$rowno) ? $i-1 : $i ;
			$t->set_var('po_fld','po'.$j) ;
			$t->set_var('part_fld','part'.$j) ;
			$t->set_var('qty_fld','qty'.$j);
			$t->set_var('po_list',str_replace("'$po'","'$po' selected",$po_list));
			$t->set_var('parts_list',str_replace("'$part'","'$part' selected",$part_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done");	else	$t->set_var('rowno',$row_.$j);
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('po_fld','po'.$i) ;
		$t->set_var('po_list',$po_list);
		$t->set_var('part_fld','part'.$i) ;
		$t->set_var('parts_list',$part_list);
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_controltot',lang('Quantity Control Total'));
	$t->set_var('controltot',$dt[controltot]) ;

	$t->parse('out','report',True);
	}

//---- Goods Receipt Post Initialisation

    function gr_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][source] = "GR" ;
	$ckapi[params_post][dt][to_from] = $ckapi[params_post][dt][vendor] ;
	}

//---- Goods Receipt Post - PreCommit Routine

    function gr_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$phpgw->db->query("DELETE from ${pre}inv_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['part'.$i]);$i++) {
			$po	= $dt['po'.$i] ;
			$part	= $dt['part'.$i];
			$qty	= $dt['qty'.$i];
			$sql = "INSERT INTO ${pre}inv_trans (trans_id,order_id,parts_id,qty,transdate)" ;
			$sql.= "VALUES ('$id','$po','$part','$qty','$dt[transdate]')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>
