<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.inventory.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

	class inventory {  

//---- Inventory Read

    function inventory_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniqueflds = $ckapi[params][uniqueflds] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from ${pre}parts where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[oldprice] = $phpgw->db->f('price') ;
	$dt[oldcost] = $phpgw->db->f('cost') ;
	$sql = "select tax_id from ${pre}itemtax a,${pre}tax b where item_id = '$id'" ;
	$phpgw->db->query("$sql and taxtype=1 and a.tax_id=b.id and b.taxgroup='ap'");
	$phpgw->db->next_record();
	$dt[aptax1] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("$sql and taxtype=2 and a.tax_id=b.id and b.taxgroup='ap'");
	$phpgw->db->next_record();
	$dt[aptax2] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("$sql and taxtype=1 and a.tax_id=b.id and b.taxgroup='ar'");
	$phpgw->db->next_record();
	$dt[artax1] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("$sql and taxtype=2 and a.tax_id=b.id and b.taxgroup='ar'");
	$phpgw->db->next_record();
	$dt[artax2] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("$sql and taxtype=1 and a.tax_id=b.id and b.taxgroup='cs'");
	$phpgw->db->next_record();
	$dt[cstax1] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("$sql and taxtype=2 and a.tax_id=b.id and b.taxgroup='cs'");
	$phpgw->db->next_record();
	$dt[cstax2] = $phpgw->db->f('tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Inventory Detail Validation Checks

    function inventory_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	if ($dt[partnumber]=="")			$err=lang("Part Name/Number Missing");
	if ($dt[rop] and !is_numeric($dt[rop]))		$err=lang("Invalid Reorder Level, must be numeric");
	if ($dt[weight] and !is_numeric($dt[weight]))	$err=lang("Invalid Weight, must be numeric");
	if ($dt[listprice] and !is_numeric($dt[listprice]))
							$err=lang("Invalid list price, must be numeric");
	if ($dt[price] and !is_numeric($dt[price]))
							$err=lang("Invalid selling price, must be numeric");
	if ($dt[cost] and !is_numeric($dt[cost]))	$err=lang("Invalid Cost, must be numeric");
	if ($dt[listprice] and $dt[price] and ($dt[listprice]<$dt[price]))
							$err=lang("List Price < Selling Price");
	if ($dt[partnumber]<>$dt[oldpartnumber]) {
		$phpgw->db->query("SELECT * FROM ${pre}parts where partnumber='$dt[partnumber]'");
		if ($phpgw->db->num_rows()>0)		$err=lang("Inventory Item Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Inventory Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$invtran = lang('inventory transaction') ;
	$invoice = lang('invoice') ; $order = lang('order');
	$quote = lang('quotation'); $cashsale = lang('cash sale') ;
	$errmsg1 = lang("This inventory part is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}inv_trans WHERE parts_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $invtran id#".$phpgw->db->f('trans_id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}invoice WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $invoice id#".$phpgw->db->f('trans_id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}oitem WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $order/$quote id#".$phpgw->db->f('trans_id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cashsale id#".$phpgw->db->f('trans_id') ;
		}
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Inventory Detail

    function inventory_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_tbi',lang("(To be implemented)"));
	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_number',lang("Name/Number"));
	$t->set_var('lang_description',lang("Description"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_photo',lang("Photo :"));
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_quantity',lang("Quantity"));
	$t->set_var('lang_bin',lang("Bin Location"));
	$t->set_var('lang_rop',lang("Reorder Level (info only)"));
	$t->set_var('lang_unit',lang("Unit"));
	$t->set_var('lang_weight',lang("Weight"));
	$t->set_var('lang_pricecost',lang("Price/Cost"));
	$t->set_var('lang_listprice',lang("List Price"));
	$t->set_var('lang_price',lang("Selling Price"));
	$t->set_var('lang_priceupdate',lang("Price Last Updated on"));
	$t->set_var('lang_cost',lang("Standard Cost"));
	$t->set_var('lang_costupdate',lang("Cost Last Updated on"));
	$t->set_var('lang_notes',lang("Notes"));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_inventory_accno',lang("Inventory Account"));
	$t->set_var('lang_income_accno',lang("Sales Account"));
	$t->set_var('lang_expense_accno',lang("COGS Account"));
	$t->set_var('lang_tax',lang("Tax"));
	$t->set_var('lang_aptax1',lang("Primary Tax Paid to Vendor"));
	$t->set_var('lang_aptax2',lang("Secondary Tax Paid to Vendor"));
	$t->set_var('lang_artax1',lang("Primary Tax from Customer"));
	$t->set_var('lang_artax2',lang("Secondary Tax from Customer"));
	$t->set_var('lang_cstax1',lang("Primary Tax for Cash Sale"));
	$t->set_var('lang_cstax2',lang("Secondary Tax for Cash Sale"));
	$t->set_var('lang_reserved',lang('Reserved Space'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('partnumber',$dt[partnumber]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('description',$dt[description]);
	$t->set_var('bin',$dt[bin]);
	$t->set_var('notes',$dt[notes]);
	$t->set_var('rop',$dt[rop]);
	$t->set_var('unit',$dt[unit]);
	$t->set_var('weight',$dt[weight]);
	$t->set_var('listprice',$dt[listprice]);
	$t->set_var('price',$dt[price]);
	$t->set_var('oldprice',$dt[oldprice]);
	$t->set_var('priceupdate',$dt[priceupdate]);
	$t->set_var('cost',$dt[cost]);
	$t->set_var('oldcost',$dt[oldcost]);
	$t->set_var('costupdate',$dt[costupdate]);
	$inv_acc = $dt[inventory_accno_id] ;
	$t->set_var('inventory_accno',$inv_acc);
	$t->set_var('invacc_sl',account_selectlist("WHERE link like '%IC:%' or link like '%IC'",$inv_acc));
	$inc_acc = $dt[income_accno_id] ;
	$t->set_var('income_accno',$inc_acc);
	$t->set_var('incacc_sl', account_selectlist("WHERE link like '%IC_sale%'",$inc_acc));
	$exp_acc = $dt[expense_accno_id] ;
	$t->set_var('expense_accno',$exp_acc);
	$t->set_var('expacc_sl',account_selectlist("WHERE link like '%IC_cogs%'",$exp_acc));
	$t->set_var('aptax1_selectlist',tax_selectlist("WHERE taxgroup='ap'",$dt[aptax1]));
	$t->set_var('aptax2_selectlist',tax_selectlist("WHERE taxgroup='ap'",$dt[aptax2]));
	$t->set_var('artax1_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[artax1]));
	$t->set_var('artax2_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[artax2]));
	$t->set_var('cstax1_selectlist',tax_selectlist("WHERE taxgroup='cs'",$dt[cstax1]));
	$t->set_var('cstax2_selectlist',tax_selectlist("WHERE taxgroup='cs'",$dt[cstax2]));

	$img = $ckapi[hostsys][dataarea]."/images/$dt[id].png" ;
	$t->set_var('image',$phpgw->link("/ck-inv/inventoryview_image.php","imgfile=$img"));

	$t->parse('out','report',True);
	}

//---- Inventory Post Initialisation

    function inventory_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;

	$dt[priceupdate] = ($dt[oldprice]<>$dt[price] or $op=='new') ? date("Y-m-d") : $dt[priceupdate] ;
	$dt[costupdate] = ($dt[oldcost]<>$dt[cost] or $op=='new') ? date("Y-m-d") : $dt[costupdate] ;
	}

//---- Inventory Post - PreCommit Routine

    function inventory_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM ${pre}itemtax WHERE item_id=$id") ;
	if ($op<>'delete') {
		$sql="INSERT INTO ${pre}itemtax (item_id,tax_id,taxtype) " ;
		if ($dt[aptax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[aptax1]','1')");
		if ($dt[aptax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[aptax2]','2')");
		if ($dt[artax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[artax1]','1')");
		if ($dt[artax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[artax2]','2')");
		if ($dt[cstax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[cstax1]','1')");
		if ($dt[cstax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[cstax2]','2')");
		}
	}

    }

?>