<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.addon.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class addon {

//---- AddOn Read

    function addon_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from ${pre}addon where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$sql = "SELECT tax_id from ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=1 and a.tax_id=b.id and b.taxgroup='cs'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[cstax1] = $phpgw->db->f('tax_id') ;
	$sql = "SELECT tax_id from ${pre}itemtax a, ${pre}tax b " ;
	$sql.= "WHERE item_id = '$id' and taxtype=2 and a.tax_id=b.id and b.taxgroup='cs'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[cstax2] = $phpgw->db->f('tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}


//---- Addon Detail Validation Checks

    function addon_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	if (!$dt[name] or $dt[name]=="")		$err=lang('AddOn Charge/Reduction Name missing');
		else	{
			$phpgw->db->query("SELECT * from ${pre}addon WHERE name='$dt[name]'") ;
			if ($phpgw->db->num_rows()<>0 and $dt[name]<>$dt[oldname])
				$err=lang('AddOn Charge/Reduction name already in use');
			}
	if ($dt[factor] and !is_numeric($dt[factor]))	$err=lang('Factor must be numeric');
	if ($dt[factor]<0 and !$dt[minsale])		$err=lang('Min Sale missing');
	if ($dt[factor]>0 and !$dt[maxsale])		$err=lang('Max Sale missing');
	if ($dt[mincount]>$dt[maxcount])		$err=lang('Min count must be <= Max count');
	if ($dt[minsale]>$dt[maxsale])			$err=lang('Min Sale must be <= Max value');
	if ($dt[mincount] and !is_numeric($dt[mincount]))	$err=lang("Min count must be numeric");
	if ($dt[maxcount] and !is_numeric($dt[maxcount]))	$err=lang("Max count must be numeric");
	if ($dt[minsale] and !is_numeric($dt[minsale]))	$err=lang("Min value must be numeric");
	if ($dt[maxsale] and !is_numeric($dt[maxsale]))	$err=lang("Max Sale must be numeric");
	if (input2date($dt[start])=="")			$err=lang('Invalid [Valid from] Date');
	if (input2date($dt[endd])=="")			$err=lang('Invalid [Valid to] Date');
	if (strtotime($dt[start])>strtotime($dt[endd]))	$err=lang('[Valid from] LaterThan [Valid to]');
	if (strtotime($dt[start])=="-1")		$err=lang("[Valid from] beyond valid date range");
	if (strtotime($dt[endd])=="-1")			$err=lang("[Valid to] beyond valid date range");
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Addon Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$cashsale = lang('cash sale') ;
	$errmsg1 = lang("This addon is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cashsale id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write AddOn Charge/Discount Detail

    function addon_write() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_splan_id',lang('Sales Promotion ID:')."  ");
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_factor',lang('Factor (based on Cash Sale Total)'));
	$t->set_var('lang_mincount',lang('Min count per Tran'));
	$t->set_var('lang_maxcount',lang('Max count per Tran'));
	$t->set_var('lang_minsale',lang('Min ($)sale per Tran'));
	$t->set_var('lang_maxsale',lang('Max ($)sale per Tran'));
	$t->set_var('lang_start',lang('Valid from'));
	$t->set_var('lang_endd',lang('Valid to'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_basis',lang('Calculation Basis (g/n)'));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts and Tax Detail"));
	$t->set_var('lang_income_accno',lang("Income / Tax"));
	$t->set_var('lang_expense_accno',lang("Expense"));
	$t->set_var('lang_cstax1',lang("Primary Tax for the Addon"));
	$t->set_var('lang_cstax2',lang("Secondary Tax for the Addon"));
	$t->set_var('lang_reserved',lang("Reserved Space"));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('splan_id',$dt[splan_id]);
	$t->set_var('name',$dt[name]);
	$t->set_var('factor',$dt[factor]);
	$t->set_var('mincount',$dt[mincount]);
	$t->set_var('maxcount',$dt[maxcount]);
	$t->set_var('minsale',$dt[minsale]);
	$t->set_var('maxsale',$dt[maxsale]);
	$t->set_var('start',$dt[start]);
	$t->set_var('endd',$dt[endd]);
	$t->set_var('notes',$dt[notes]);
	$basis = $dt[basis] ;
	$basis_sl ="<OPTION value='g'>".lang('g - Gross Cash Sale')."</OPTION>" ;
	$basis_sl.="<OPTION value='n'>".lang('n - Net Cash Sale')."</OPTION>";
	$basis_sl = str_replace("'$basis'","'$basis'"." selected",$basis_sl) ;
	$t->set_var('basis_option_block',$basis_sl );
	$inc_accno = $dt[incacc_id] ;
	$t->set_var('inc_accno',$inc_accno);
	$t->set_var('inc_acc_option_block', account_selectlist("WHERE link like '%SV_income%' or link like '%CS_tax%'",$inc_accno));
	$exp_accno = $dt[expacc_id] ;
	$t->set_var('exp_accno',$exp_accno);
	$t->set_var('exp_acc_option_block', account_selectlist("WHERE link like '%SV_expense%'",$exp_accno));
	$t->set_var('cstax1_selectlist',tax_selectlist("WHERE taxgroup='cs'",$dt[cstax1]));
	$t->set_var('cstax2_selectlist',tax_selectlist("WHERE taxgroup='cs'",$dt[cstax2]));

	$t->parse('out','report',True);
	}

//---- AddOn Post Initialisation

    function addon_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt[splan_id] = ($dt[splan_id]=="") ? 0 : $dt[splan_id] ;
	}

//---- AddOn Post - PreCommit Routine

    function addon_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	$table = "${pre}itemtax" ;

	if ($op<>'new')		$phpgw->db->query("DELETE FROM $table WHERE item_id=$id") ;
	if ($op<>'delete') {
		$sql="INSERT INTO $table (item_id,tax_id,taxtype) " ;
		if ($dt[cstax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[cstax1]','1')");
		if ($dt[cstax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[cstax2]','2')");
		}
	}

    }

?>
