<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.cbtran.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class cbtran {

//---- CashBox List SQL Formation

    function cbtran_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$sql =  "SELECT cbtnumber,name,manager,a.cashier as cashier," ;
	$sql.=	"transdate,a.shift as shift,trantype,amount,a.id as id " ;
	$sql.=	"FROM ${pre}cbtran a, ${pre}cashbox b " ;
	$sql.=	"WHERE 1=1 $where and a.cboxid=b.id order by ".$order." ".$sort ;
	return $sql ;
	}

//---- CashBox Transaction Read

    function cbtran_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from $table where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}


//---- CashBox Transaction Detail Validation Checks

    function cbtran_validate() {
	global $ckapi,$phpgw ;

	$table = $ckapi[params][table] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$err=""; $error=lang('Error') ;
	$sos_completed = lang("Start-of-shift tran already completed") ;
	$eos_completed = lang("Cashbox closed (end-of-shift completed)") ;
	$sos_retry = lang("If necessary, delete current sos, then retry") ;
	$eos_retry = lang("If necessary, delete current eos, then retry") ;
	$cboxid = $dt[cboxid] ;
	$transdate = $dt[transdate] ;
	$shift = $dt[shift] ;
	$trantype = $dt[trantype] ;
	$amount = $dt[amount] ;
	if (!$dt[cbtnumber] or $dt[cbtnumber]=="")		$err=lang('CashBox Transaction Name missing');
		else	{
			$phpgw->db->query("SELECT * from $table WHERE cbtnumber='$dt[cbtnumber]'") ;
			if ($phpgw->db->num_rows()<>0 and $dt[cbtnumber]<>$dt[oldcbtnumber])
				$err=lang('CashBox Transaction name already in use');
			}
	if (input2date($transdate)=="")				$err=lang('Invalid Cash Sale Date');
	if (!$amount or $amount=="")				$err=lang('Transaction Amount missing');
	if (($trantype=="s" or $trantype=="+") and $amount<0)	$err=lang('s/+ trans must have +ve amount') ;
	if (($trantype=="e" or $trantype=="-") and $amount>0)	$err=lang('e/- trans must have -ve amount') ;
	$admin = False ;
	$user = $ckapi[hostsys][username];
	$groups = ExecMethod('phpgwapi.accounts.membership',$user) ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']=="Admins")	$admin = True ;
	if (!$admin)				$err=lang('User need to be an [Admins] group user');
	$sql = "SELECT * FROM $table WHERE cboxid='$cboxid' and " ;
	$sql.= "transdate='$transdate' and shift='$shift' and trantype='s'" ;
	$phpgw->db->query($sql) ;
	$exist = $phpgw->db->num_rows()>0 ;
	if ($trantype=='s' and $exist and $op<>'edit')		$err = "$sos_completed.  $sos_retry.";
	if ($trantype<>'s' and !$exist)				$err=lang("Start-of-shift tran pending");
	$sql = "SELECT * FROM $table WHERE cboxid='$cboxid' and " ;
	$sql.= "transdate='$transdate' and shift='$shift' and trantype='e'" ;
	$phpgw->db->query($sql) ;
	if ($phpgw->db->num_rows()>0 and $op<>'edit')	$err = "$eos_completed.  $eos_retry." ;
	$sql = "SELECT max(transdate) as lastdate FROM $table WHERE cboxid='$cboxid'" ;
	$phpgw->db->query($sql) ;
	$phpgw->db->next_record() ;
	$lastdate = $phpgw->db->f('lastdate') ;
	if ($lastdate<>'') {
		$sql = "SELECT max(shift) as lastshift FROM $table WHERE cboxid='$cboxid' and transdate='$lastdate'" ;
		$phpgw->db->query($sql) ;
		$lastshift = $phpgw->db->f('lastshift') ;
		if ($lastdate<>'' and $trantype=='s' and $lastdate<$transdate)	{
			$sql = "SELECT * from $table where cboxid='$cboxid' and " ;
			$sql.= "transdate='$lastdate' and shift='$lastshift' and trantype='e'" ;
			$phpgw->db->query($sql) ;
			$sshift = lang("shift") ;
			if (!$phpgw->db->next_record())
				$err=lang("Cashbox not closed on")." [$lastdate] $sshift [$lastshift]";
			}
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- CashBox Transaction Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$completed = lang("Cashbox closed (end-of-shift completed)") ;
	$retry = lang("If necessary, delete current eos, then retry") ;
	$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
	$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
	$phpgw->db->query($sql) ;
	if ($phpgw->db->num_rows()>0 and $dt[trantype]<>'e')	$err = "$completed.  $retry." ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write CashBox Transaction Detail

    function cbtran_write() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_cbtnumber',lang('CashBox Transaction #')."  ");
	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_cboxid',lang('Cash Box ID')."  ");
	$t->set_var('lang_manager',lang('Manager:'));
	$t->set_var('lang_cashier',lang('Cashier'));
	$t->set_var('lang_transdate',lang('Cash Sale Date'));
	$t->set_var('lang_shift',lang('Shift'));
	$t->set_var('lang_trantype',lang('Transaction Type'));
	$t->set_var('lang_amount',lang('Transaction Amount'));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_poscashac',lang("Cash at Point of Sale"));
	$t->set_var('lang_citac',lang("Cash in transit"));

	$t->set_var('cbtnumber',$dt[cbtnumber]) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('cboxid',$dt[cboxid]);
	$t->set_var('cboxid_sl',cboxid_selectlist("",$dt[cboxid]));
	$t->set_var('manager',$dt[manager]);
	$t->set_var('cashier',$dt[cashier]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('shift',$dt[shift]);
	$t->set_var('shift_sl',shift_selectlist("",$dt[shift]));
	$t->set_var('trantype',$dt[trantype]);
	$t->set_var('trantype_sl',trantype_selectlist("",$dt[trantype]));
	$t->set_var('amount',$dt[amount]);
	$posac_sl = account_selectlist("WHERE link like '%CS:%' or link like '%CS'",$dt[posac_id]);
	$citac_sl = account_selectlist("WHERE link like '%CS:%' or link like '%CS'",$dt[citac_id]);
	$t->set_var('posac_sl',$posac_sl);
	$t->set_var('citac_sl',$citac_sl);

	$t->parse('out','report',True);
	}

//---- CashBox Transaction Post Initialisation

    function cbtran_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt[source]	= "CBTR" ;
	$dt[description]= "CB: Cashbox Tran# $dt[cbtnumber]";
	$dt[netbal] = number_format(cashbalance($dt[cboxid],$dt[transdate],$dt[shift]),2,".",'') ;
	}

//---- CashBox Transaction Post - PreCommit Routine

    function cbtran_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;

	if ($op<>'new')		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id='$id'");
	if ($op<>'delete') {
		$posac_id = $dt[posac_id] ;
		$transdate = $dt[transdate] ;
		$amount = $dt[amount] ;
		$negamount = -$dt[amount] ;
		$sql1 = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) " ;
		$phpgw->db->query("$sql1 VALUES ('$id','$posac_id','$negamount','$transdate')");
		$phpgw->db->query("$sql1 VALUES ('$id','$dt[citac_id]','$amount','$transdate')");
		if ($dt[trantype]=='e') {
			$netbal = $dt[netbal] + $amount;
			$negnetbal = -$netbal ;
			if ($netbal<>0)	{
				$lang_misexp = lang('Miscellaneous Expense') ;
				$sql = "SELECT id from ${pre}chart " ;
				$sql.= "WHERE lower(description) like lower('%$lang_misexp%')" ;
				$phpgw->db->query($sql);
				$phpgw->db->next_record() ;
				$misexp = $phpgw->db->f('id') ;
				$phpgw->db->query("$sql1 VALUES ('$id','$posac_id','$netbal','$transdate')");
				$phpgw->db->query("$sql1 VALUES ('$id','$misexp','$negnetbal','$transdate')");
				}
			}
		}
	}

    }

?>
