<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.package.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class package {

//---- Package List SQL Formation

    function package_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$sql =  "SELECT distinct a.* FROM ${pre}service a, ${pre}assembly b " ;
	$sql.=  "WHERE a.id=b.assembly_id $where order by ".$order." ".$sort ;
	return $sql ;
	}

//---- Package Read

    function package_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT control FROM ${pre}service WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$phpgw->db->query("SELECT * from ${pre}assembly WHERE assembly_id='$id' order by id");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['item_id'.$i] = $phpgw->db->f('item_id') ;
		$dt['qty'.$i] = $phpgw->db->f('qty') ;
		}
	$dt[package] = $dt[id] = $id ;
	return $dt ;
	}

//---- Package Add Initialisation

    function package_add_init() {
	global $ckapi ;

	$ckapi[params_post][dt]['item_id1'] = $ckapi[params_post][dt]['qty1'] = "" ;
	}

//---- Package Validation Checks

    function package_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$err=""; $error=lang("Error") ;
	if ($op<>'edit')	{
		$phpgw->db->query("SELECT distinct * from ${pre}assembly where assembly_id='$dt[package]'");
		if ($phpgw->db->num_rows()>0)		$err=lang("Package already exists");
		}
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		$row = lang("Row") ;  $rowi = "[$row $i]" ;
		if ($dt['item_id'.$i]==$dt[package])	$err=$rowi.lang("Package cannot be inside itself");
		if (!$dt['qty'.$i])			$err=$rowi.lang("Missing Component Qty");
		if ($dt['qty'.$i] and !is_numeric($dt['qty'.$i]))
							$err=$rowi.lang("Component Qty must be numeric");
		if ($dt['qty'.$i] and $dt['qty'.$i]<=0)	$err=$rowi.lang("Component Qty must be +ve");
		For ($j=1;isset($dt['item_id'.$j]);$j++) {
			$rowij = "[$row $i/$j]" ;
			if ($dt['item_id'.$i]==$dt['item_id'.$j] and $i<>$j)
							$err=$rowij.lang("Duplicative Components");
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Package Header

    function package_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_ginfo',lang("General Information"));
	$t->set_var('lang_package',lang("Package"));
	$t->set_var('lang_number',lang("Name/Number"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_description',lang("Description"));
	$t->set_var('lang_notes',lang("Notes"));

	$where = (!$uniwhere) ? " WHERE id='$dt[package]' " : $uniwhere;
	$t->set_var('service_sl',service_selectlist($where,$dt[package])) ;
	if ($dt[package]<>$dt[lastpackage]) {
		$phpgw->db->query("SELECT control FROM ${pre}service WHERE id='$dt[package]'");
		$phpgw->db->next_record();
		$dt[control] = $phpgw->db->f('control');
		}
	$t->set_var('lastpackage',$dt[package]) ;
	$t->set_var('id',$dt[package]) ;
	$dt[id] = $dt[package] ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('notes',$dt[notes]);

	$t->parse('out','report',True);
	}

//---- Write Package Detail

    function package_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_comp',lang('Component Part'));
	$t->set_var('lang_compqty',lang('Qty of Component inside Package'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_newrow',lang('Add New Row'));
	$item_list = item_selectlist("",'') ;
	if (isset($delete)) {$rowno = intval(str_replace($row_,"",$delete)); }
	For ($i=1;isset($dt['item_id'.$i]);$i++) {
		if ($i<>$rowno) {
			$item_id	=	$dt['item_id'.$i] ;
			$qty		=	$dt['qty'.$i] ;
			if (isset($delete) and $i>$rowno) {$j=$i-1;} else {$j=$i;}
			$t->set_var('item_fld','item_id'.$j) ;
			$t->set_var('qty_fld','qty'.$j) ;
			$t->set_var('item_sl',str_replace("'$item_id'","'$item_id' selected",$item_list));
			$t->set_var('qty',$qty) ;
			if ($posted)	$t->set_var('rowno',"done") ;	else	$t->set_var('rowno',$row_.$j) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			}
		}
	if ($i==2 and $rowno==1)			$i=1 ;
	if ($i==1)					$newrow=True ;
	if ($newrow) {
		$t->set_var('item_fld','item_id'.$i) ;
		$t->set_var('qty_fld','qty'.$i);
		$t->set_var('item_sl',$item_list);
		$t->set_var('qty',"") ;
		$t->set_var('rowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Package Post Initialisation

    function package_post_init() {
	global $ckapi ;

	if ($ckapi[params_post][op]=='new')	$ckapi[params_post][op] = 'edit' ;
	}

//---- Package Post - PreCommit Routine

    function package_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$id = $dt[package] ;
	if ($op<>'new')	$phpgw->db->query("DELETE FROM ${pre}assembly WHERE assembly_id=$id");
	if ($op<>'delete') {
		$sql1 = "INSERT INTO ${pre}assembly (assembly_id,item_id,qty) " ;
		For ($i=1;isset($dt['item_id'.$i]);$i++) {
			$item_id	= $dt['item_id'.$i];
			$qty		= $dt['qty'.$i] ;
			$sql = "$sql1 VALUES ('$id','$item_id','$qty')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>
