<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.expc.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class expc {

//---- Expc List SQL Formation

    function expc_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$where = str_replace("approved_by=''","(approved_by='' or approved_by is NULL)",$where) ;
	$sql =	"SELECT b.name as staff,c.name as name,description," ;
	$sql.=	"a.qty,a.unit,a.unitamt,a.rate,a.amount,comment,approved_by,a.id " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}employee b, ${pre}pyrcode c " ;
	$sql.=	"WHERE $where and empid=b.id and pyrcodeid=c.id order by $order $sort" ;

	return $sql ;
	}

//---- Expc List Link Adjustement

    function expc_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]=='')
		$t->set_var(array(	'lang_cancel'	=> '',
					'cancel'	=> ''	)) ;
	  else	$t->set_var(array(	'lang_approve'	=> '',
					'lang_reject'	=> '',
					'approve'	=> '',
					'reject'	=> ''	)) ;
	}

//---- Expc Read

    function expc_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$sql =	"SELECT a.empid,salary,period,pyrcodeid as eaid,basis,a.qty,a.unit," ;
	$sql.=	"a.unitamt,a.rate,a.amount,comment,approved_by,a.id,a.control " ;
	$sql.=	"FROM ${pre}pynr_trans a, ${pre}payroll b, ${pre}pyrcode c " ;
	$sql.=	"WHERE a.id='$id' and a.empid=b.empid and pyrcodeid=c.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $phpgw->db->f('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;
	return $dt ;
	}

//---- Expc Add Initialisation

    function expc_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT id FROM ${pre}employee WHERE username='$user'");
	$phpgw->db->next_record();
	$ckapi[params_post][dt][empid] = $phpgw->db->f('id');
	}


//---- Expc Validation Checks

    function expc_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$err="";
	$error = lang("Error") ;
	if ($dt[reason]=="")	$err=lang("Cancel/Reject Reason Missing") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Expc Detail

    function expc_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_salary',lang('Basic Salary'));
	$t->set_var('lang_period',lang('Pay Period'));
	$t->set_var('lang_daypay',lang('Imputed Daily Pay'));
	$t->set_var('lang_hourpay',lang('Imputed Hourly Pay'));
	$t->set_var('lang_eaid',lang('Expense/Allowance Type'));
	$t->set_var('lang_basis',lang('Basis of Calculation'));
	$t->set_var('lang_qty',lang('Quantity'));
	$t->set_var('lang_unit',lang('Unit'));
	$t->set_var('lang_unitamt',lang('Unit Amount'));
	$t->set_var('lang_rate',lang('Pay Rate'));
	$t->set_var('lang_amount',lang('Amount'));
	$t->set_var('lang_comment',lang('Comment'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$sql = "SELECT b.username FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$empid' and a.supervisor=b.id";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$where = " WHERE id='$dt[empid]' " ;

	$t->set_var('empid_selectlist',employee_selectlist($where,$dt[empid])) ;
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('salary',$dt[salary]);
	$t->set_var('period',$dt[period]) ;
	$t->set_var('daypay',$dt[daypay]);
	$t->set_var('hourpay',$dt[hourpay]) ;
	$where = "WHERE allowssc='y'" ;
	$eaid = ($dt[eaid]=="") ? 0 : $dt[eaid] ;
	$t->set_var('eaid_selectlist',eaid_selectlist($where,$eaid,'long')) ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var("lasteaid",$eaid);

	$qty = 1 ;
	$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$eaid'");
	$phpgw->db->next_record();
	$basis		=	$phpgw->db->f('basis') ;
	$unit		=	$phpgw->db->f('unit') ;
	$unitamt	=	(substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
	$rate		=	$phpgw->db->f('rate') ;
	$dt[chart_id]	=	$phpgw->db->f('chart_id') ;
	if (substr_count($basis,'qty')>0)	{$qty = $dt[qty]; $t->set_var('qty_readonly','');}
		else				$t->set_var('qty_readonly','readonly') ;
	if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
	if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
	if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
	$amount = sprintf("%01.2f",$qty*$unitamt*$rate) ;
	if (substr_count($basis,'amt')>0)	{$amount=$dt[amount]; $t->set_var('amt_readonly','');}
		else				$t->set_var('amt_readonly','readonly') ;
	$dt[qty] = $qty ;
	$dt[unit] = $unit ;
	$dt[unitamt] = $unitamt ;
	$dt[amount] = $amount ;
	$t->set_var('basis',$basis);
	$t->set_var('qty',$qty);
	$t->set_var('unit',$unit);
	$t->set_var('unitamt',$unitamt);
	$t->set_var('rate',$rate);
	$t->set_var('amount',$amount);
	$t->set_var('comment',$dt[comment]);
	$t->set_var('approved_by',$dt[approved_by]);
	$t->set_var('reason',$dt[reason]);
	$t->parse('out','report',True);
	}

//---- Expc Post Initialisation

    function expc_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = "" ;
	}

//---- Expc Post - PostCommit Routine

    function expc_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$lang_approval = lang("Approval") ;
	$lang_reason = lang("Reason") ;
	$inform = lang("Please manually inform") ;

	$id = $dt[id] ;
	$empid = $dt[empid] ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$empid' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$phpgw->db->query("SELECT prefix,suffix FROM ${pre}email WHERE empid='$empid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
$phpgw->db->query("SELECT prefix,suffix FROM ${pre}email WHERE empid='$superid' and emailcode='BUSI'");
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;

	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;

	switch ($op) :
	    case "approve" :
		$subject = "[$staffname] $lang_tran [id#$id] $actioned." ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email approving expense/allowance claim successfully queued for despatch to") ;
		$failuremsg = lang("Email approving expense/allowance claim fails to deliver.")."  $inform" ;
		break ;
	    case "cancel" :
		$subject = "[$staffname] $lang_tran [id#$id] " ;
		$subject.= "$lang_approval $actioned.  $lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg =lang("Email advising approval cancellation successfully queued for despatch to");
		$failuremsg =lang("Email advising approval cancellation fails to deliver.")."  $inform" ;
		break ;
	    case "reject" :
		$subject = "[$staffname] $lang_tran [id#$id] $actioned.  " ;
		$subject.= "$lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email rejecting expense/allowance claim successfully queued for despatch to") ;
		$failuremsg = lang("Email rejecting expense/allowance claim fails to deliver.")."  $inform" ;
		break ;
	    endswitch ;

	if ($result)	$msg = "<br>$successmsg $staffname." ;
		else	$msg = "<br>$failuremsg $staffname." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>

