<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.leaveapp.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class leaveapp {

//---- Leave Application List SQL Formation

    function leaveapp_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$lang_leave = lang('leave') ;
	$user = $ckapi[hostsys][username];
	$sql =  "SELECT b.name as staff,a.*,description " ;
	$sql.=  "FROM ${pre}leaveapp a, ${pre}employee b, ${pre}hrcode c " ;
	$sql.=  "WHERE 1=1 $where and username='$user' and empid=b.id and leavecode=c.name and c.type='$lang_leave' " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- Leave Application List Link Adjustement

    function leaveapp_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]<>'')
		$t->set_var(array(	'lang_edit'	=> '',
					'lang_delete'	=> '',
					'edit'		=> '',
					'delete'	=> ''	)) ;
	}

//---- Leave Application Read

    function leaveapp_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("select * from ${pre}leaveapp WHERE id='$id'");
	$phpgw->db->next_record();
	return $phpgw->db->Record ;
	}

//---- Leave Application Add Initialisation

    function leaveapp_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT id FROM ${pre}employee WHERE username='$user'");
	$phpgw->db->next_record();
	$ckapi[params_post][dt][empid] = $phpgw->db->f('id');
	}


//---- Leave Application Detail Validation Checks

    function leaveapp_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = lang("Error") ;
	$leavefrom = $dt[leavefrom] ;
	$leaveto = $dt[leaveto] ;
	if (input2date($leavefrom)=="")		$err=lang("Invalid From Date");
	if (input2date($leaveto)=="")		$err=lang("Invalid To Date");
	$from = strtotime($leavefrom) ;
	$to = strtotime($leaveto) ;
	if ($from<mktime(0,0,0))		$err=lang("Leave application cannot be retrospective") ;
	if ($leavefrom<>"" and $leaveto<>"" and $from>$to)	$err=lang("From Date later than To Date") ;
	$duration = $dt[duration] ;
	if (!is_numeric($duration) or $duration=='' or $duration==0)
						$err=lang("invalid Workdays figure") ;
	if ($duration*10%5 <>0)			$err=lang("Workdays must be whole day or half a day") ;
	if ($leavefrom<>"" and $leaveto<>"" and ($to-$from)<(($duration-1)*24*60*60))
						$err=lang("Work Days > Leave Period duration") ;
	if (substr($leavefrom,0,4)<>substr($leaveto,0,4))
						$err=lang("Leave From year must equal Leave To year") ;
	$dt[id] = ($dt[id]=="") ? 0 : $dt[id] ;
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE ((leavefrom>='$leavefrom' and leavefrom<='$leaveto') " ;
	$sql.=	"or(leaveto>='$leavefrom' and leaveto<='$leaveto')) and empid='$dt[empid]' and id<>'$dt[id]'";
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0) $err=lang("This application overlaps with existing leave applications");
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE (('$leavefrom'>=leavefrom and '$leavefrom'<=leaveto) " ;
	$sql.=	"or('$leaveto'>=leavefrom and '$leaveto'<=leaveto)) and empid='$dt[empid]' and id<>'$dt[id]'";
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0) $err=lang("This application overlaps with existing leave applications");

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Leave Application Detail

    function leaveapp_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_leavefrom',lang('Leave From'));
	$t->set_var('lang_leaveto',lang('Leave To'));
	$t->set_var('lang_duration',lang('Duration in Workdays'));
	$t->set_var('lang_leavecode',lang('Leave Code -- Description'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$lang_leave = lang('leave') ;
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$phpgw->db->query("SELECT username FROM ${pre}employee WHERE id='$empid'");
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$where = " WHERE id='$dt[empid]' " ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$dt[empid])) ;
	$t->set_var('staff',$dt[staff]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('leavefrom',$dt[leavefrom]);
	$t->set_var('leaveto',$dt[leaveto]);
	$t->set_var('duration',$dt[duration]);
	$where = "WHERE type='$lang_leave' and name<>'SL' and name<>'UA'" ;
	$leavecode_sl = hrcodename_selectlist($where,$dt[leavecode],'long');
	$t->set_var('leavecode_selectlist',$leavecode_sl);
	$t->set_var('approved_by',$dt[approved_by]);
	$t->parse('out','report',True);
	}

//---- Leave Application Post Initialisation

    function leaveapp_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = "" ;
	}

//---- Leave Application Post - PostCommit Routine

    function leaveapp_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$lang_from = lang("FROM") ;
	$lang_to = lang("TO") ;
	$inform = lang("Please manually inform") ;
	$leavefrom = $dt[leavefrom] ;
	$leaveto = $dt[leaveto] ;

	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$dt[empid]' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$superid' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$supername < $superemail >" ;
	$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] $actioned." ;
	if ($op<>'delete')   $subject.=' => '.lang('Please approve');
	$message = '' ;
	$headers = "From: $staffname < $staffemail >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $staffname < $staffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($op=='delete') {
		$successmsg = lang("Email advising action on leave application successfully queued for despatch to") ;
		$failuremsg=lang("Email advising action on leave application fails to deliver.")."  $inform";
		}
	  else  {
		$successmsg = lang("Email requesting leave application approval successfully queued for despatch to") ;
		$failuremsg=lang("Email requesting leave application approval fails to deliver.")."  $inform";
		}
	if ($result)	$msg = "<br>$successmsg $supername." ;
		else	$msg = "<br>$failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}


    }

?>

