<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.timesheet.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class timesheet {

//---- Timesheet List SQL Formation

    function timesheet_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$user = $ckapi[hostsys][username];
	$sql =	"SELECT name,year,week,hour_ttl,day_ttl,approved_by,a.id " ;
	$sql.=	"FROM ${pre}timesheet a, ${pre}employee b  ";
	$sql.=	"WHERE 1=1 $where and username='$user' and empid=b.id ORDER BY ".$order." ".$sort ;
	return $sql ;
	}

//---- Timesheet List Link Adjustement

    function timesheet_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]<>'')
		$t->set_var(array(	'lang_edit'	=> '',
					'lang_delete'	=> '',
					'edit'		=> '',
					'delete'	=> ''	)) ;
	}

//---- Timesheet Read

    function timesheet_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$sql = "SELECT a.* FROM ${pre}timesheet a,${pre}employee b " ;
	$sql.= "WHERE a.id=$id and empid=b.id";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$sql = "SELECT a.*,b.* FROM ${pre}ts_trans a, ${pre}timesheet b " ;
	$sql.= "WHERE trans_id='$id' and a.trans_id=b.id ORDER BY a.id";
	$phpgw->db->query($sql);
	$dt[tsyear0] = date("Y") ;
	$dt[tsmonth0] = date("m") ;
	$dt[tsday0] = date("d") ;
	For ($i=1;$phpgw->db->next_record();$i++) {
		$transdate		=	$phpgw->db->f('transdate') ;
		$dt['tsyear'.$i]	=	substr($transdate,0,4) ;
		$dt['tsmonth'.$i]	=	substr($transdate,5,2) ;
		$dt['tsday'.$i]		=	substr($transdate,8,2) ;
		$dt['project'.$i]	=	$phpgw->db->f('project') ;
		$dt['activity'.$i]	=	$phpgw->db->f('activity') ;
		$dt['hour'.$i]		=	$phpgw->db->f('hour') ;
		$dt['day'.$i]		=	$phpgw->db->f('day') ;
		$dt['achieve'.$i]	=	$phpgw->db->f('achieve') ;
		$dt['achival'.$i]	=	$phpgw->db->f('achival') ;
		$dt['achiunit'.$i]	=	$phpgw->db->f('achiunit') ;
		}
	return $dt ;
	}

//---- Timesheet Add Initialisation

    function timesheet_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT id FROM ${pre}employee WHERE username='$user'");
	$phpgw->db->next_record();
	$ckapi[params_post][dt][empid] = $phpgw->db->f('id');
	$ckapi[params_post][dt][year] = date("Y") ;
	$ckapi[params_post][dt][week] = date("W",mktime(0,0,0,date("m"),date("d"),date("Y"))) ;
	$ckapi[params_post][dt][tsyear0] = $ckapi[params_post][dt][tsyear1] = date("Y") ;
	$ckapi[params_post][dt][tsmonth0] = $ckapi[params_post][dt][tsmonth1] = date("m") ;
	$ckapi[params_post][dt][tsday0] = $ckapi[params_post][dt][tsday1] = date("d") ;
	}

//---- timesheet Validation Checks

    function timesheet_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$lang_na = lang('not_applicable') ;
	$lang_leave = strtolower(lang('leave')) ;
	$err="";
	$error = lang("Error") ;
	$row = lang("Row") ;
	$phpgw->db->query("SELECT * FROM ${pre}achievement WHERE name='$lang_na'");
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$achinaid = $phpgw->db->f('id');
	$leavecodes = hrcodename_selectlist("WHERE lower(type)='$lang_leave'",'','short') ;
	$hour_ttl = 0 ;
	For ($i=1;isset($dt['tsyear'.$i]);$i++) {
		$rowi = "[$row $i] " ;
		$tsyear = $dt['tsyear'.$i] ;
		$tsmonth = $dt['tsmonth'.$i] ;
		$tsday = $dt['tsday'.$i] ;
		$date = input2date("$tsyear-$tsmonth-$tsday") ;
		$activity = $dt['activity'.$i] ;
		$hour = $dt['hour'.$i] ;
		$day = $dt['day'.$i] ;
		if ($date=="")				$err=$rowi.lang("Invalid Date");
		$dateweek = date('W',mktime(0,0,0,$tsmonth,$tsday,$tsyear)) ;
		if ($dateweek<>$dt[week])		$err=$rowi.lang("Date not compatible to Week") ;
		if ($activity=='')			$err=$rowi.lang("Invalid Activity") ;
		   else	if (substr_count($leavecodes,$dt['activity'.$i])==0)	{
				if (!is_numeric($hour) or $hour<=0)	$err=$rowi.lang("Invalid Hour") ;
				if ($day<>0)				$err=$rowi.lang("Invalid Day") ;
				}
			else {	if ($hour<>0)				$err=$rowi.lang("Invalid Hour") ;
				if ($day==0)				$err=$rowi.lang("Invalid Day") ;
		   		}
		$hour_ttl += $hour ;
		$day_ttl += $day ;
		if ($dt['achival'.$i]=='' and $dt['achiunit'.$i]=='' and $dt['achieve'.$i]<>$achinaid)
			$err=$rowi.lang("Since Achievement<>not_applicable, value or unit must be non-blank");
		if ($day==0)	continue ;
		if ($dt[id]=='')	$dt[id]=0 ;
		$sql =	"SELECT * FROM ${pre}leave WHERE leavefrom<='$date' and leaveto>='$date' " ;
		$sql.=				"and empid='$dt[empid]' and trans_id<>'$dt[id]'" ;
		$phpgw->db->query($sql);
		if ($phpgw->db->num_rows()>0)
			$err=$rowi.lang("Leave day falls within period(s) included in existing leave record");
		}
	if ($hour_ttl<>$dt[hour_ttl])			$err=lang("Invalid Total Hours") ;
	if ($day_ttl<>$dt[day_ttl])			$err=lang("Invalid Total Days") ;
	$sql = "SELECT * FROM ${pre}timesheet " ;
	$sql.= "WHERE empid='$dt[empid]' and year='$dt[year]' and week='$dt[week]'" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	if ($phpgw->db->num_rows()<>0 and $phpgw->db->f('id')<>$dt[id])
				$err=lang("Timesheet for the specified week already exist") ;
	$user = $ckapi[hostsys][username];
	$err1 = lang("Such address is needed to despatch email requesting timesheet approval") ;
	$sql = "SELECT * from ${pre}email a, ${pre}employee b " ;
	$sql.= "WHERE empid=b.id and username='$user' and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	{
		$err0 = lang("You don't have a BUSI email address on record") ;
		$err = "$err0.  $err1." ;
		}
	$sql = "SELECT * from ${pre}email a, ${pre}employee b, ${pre}employee c " ;
	$sql.= "WHERE empid=b.id and c.supervisor=b.id and c.username='$user' and emailcode='BUSI'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	{
		$err0 = lang("Your Supervisor don't have a BUSI email address on record") ;
		$err = "$err0.  $err1." ;
		}
	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Timesheet Header

    function timesheet_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',lang('Employee'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_year',lang('Year'));
	$t->set_var('lang_week',lang('Week'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$phpgw->db->query("SELECT username FROM ${pre}employee WHERE id='$empid'");
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$where = " WHERE id='$empid' " ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$empid)) ;
	$t->set_var('year_selectlist',year_selectlist('',$dt[year])) ;
	$t->set_var('week_selectlist',week_selectlist('',$dt[week])) ;
	$t->set_var('approved_by',$dt[approved_by]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->parse('out','report',True);
	}

//---- Reformat Timesheet Array

    function timesheet_transform() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	if (isset($ckapi[buttons][replicate])) {
		For ($i=1;isset($dt['tsyear'.$i]);$i++) {
			$dt['tsyear'.$i]	=	$dt['tsyear0'] ;
			$dt['tsmonth'.$i]	=	$dt['tsmonth0'] ;
			$dt['tsday'.$i]		=	$dt['tsday0'] ;
			}
		}
	}

//---- Write Timesheet Detail

    function timesheet_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang('Row')." " ;
	$lang_activity = lang('activity') ;
	$lang_leave = lang('leave') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_pah',lang('Project---Activity/Leave---Hours---Days'));
	$t->set_var('lang_achievement',lang('Result Achieved'));
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_tsyear',lang('Year'));
	$t->set_var('lang_tsmonth',lang('Month'));
	$t->set_var('lang_tsday',lang('Day'));
	$t->set_var('lang_project',lang('Project'));
	$t->set_var('lang_activity',lang('Activity/Leave'));
	$t->set_var('lang_hour',lang('Hour Worked'));
	$t->set_var('lang_day',lang('Days On Leave'));
	$t->set_var('lang_achieve',lang('Achievement'));
	$t->set_var('lang_achival',lang('Value'));
	$t->set_var('lang_achiunit',lang('Unit'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('tsyear0_selectlist',year_selectlist('',$dt[tsyear0],'short')) ;
	$t->set_var('tsmonth0_selectlist',month_selectlist('',$dt[tsmonth0],'short')) ;
	$t->set_var('tsday0_selectlist',day_selectlist('',$dt[tsday0],'short')) ;

	$nullopt = "<OPTION value=''></OPTION>" ;
	$act_sl = hrcodename_selectlist("WHERE type='$lang_activity'",'','long') ;
	$act_sl.= $nullopt ;
	$act_sl.= "<OPTION value=''>".lang('On Leave (Pls enter -0- as hours worked)')."</OPTION>" ;
	$act_sl.= hrcodename_selectlist("WHERE type='$lang_leave'",'','long') ;
	$lang_day = lang('day') ;
	$day_sl = $nullopt."<OPTION value='1'>1 $lang_day</OPTION><OPTION value='0.5'>0.5 $lang_day</OPTION>" ;
	$hour_ttl = 0;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['tsyear'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('tsyear_fld','tsyear'.$i) ;
			$t->set_var('tsmonth_fld','tsmonth'.$i) ;
			$t->set_var('tsday_fld','tsday'.$i) ;
			$t->set_var('project_fld','project'.$i) ;
			$t->set_var('activity_fld','activity'.$i) ;
			$t->set_var('hour_fld','hour'.$i) ;
			$t->set_var('day_fld','day'.$i) ;
			$t->set_var('achieve_fld','achieve'.$i);
			$t->set_var('achival_fld','achival'.$i);
			$t->set_var('achiunit_fld','achiunit'.$i);
			$t->set_var('tsyear_selectlist',year_selectlist('',$dt['tsyear'.$i],'short')) ;
			$t->set_var('tsmonth_selectlist',month_selectlist('',$dt['tsmonth'.$i],'short')) ;
			$t->set_var('tsday_selectlist',day_selectlist('',$dt['tsday'.$i],'short')) ;
			$t->set_var('project_selectlist',$nullopt.project_selectlist('','',short)) ;
			$t->set_var('activity_selectlist',$act_sl);
			$t->set_var('hour','') ;
			$t->set_var('day_selectlist',$day_sl);
			$t->set_var('achieve_selectlist',achieve_selectlist("","",'short')) ;
			$t->set_var('achival','') ;
			$t->set_var('achiunit','') ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$t->set_var('tsyear_fld','tsyear'.$j) ;
		$t->set_var('tsmonth_fld','tsmonth'.$j) ;
		$t->set_var('tsday_fld','tsday'.$j) ;
		$t->set_var('project_fld','project'.$j) ;
		$t->set_var('activity_fld','activity'.$j) ;
		$t->set_var('hour_fld','hour'.$j) ;
		$t->set_var('day_fld','day'.$j) ;
		$t->set_var('achieve_fld','achieve'.$j);
		$t->set_var('achival_fld','achival'.$j);
		$t->set_var('achiunit_fld','achiunit'.$j);
		$t->set_var('tsyear_selectlist',year_selectlist('',$dt['tsyear'.$i],'short')) ;
		$t->set_var('tsmonth_selectlist',month_selectlist('',$dt['tsmonth'.$i],'short')) ;
		$t->set_var('tsday_selectlist',day_selectlist('',$dt['tsday'.$i],'short')) ;
		$t->set_var('project_selectlist',$nullopt.project_selectlist('',$dt['project'.$i],'short')) ;
		$default = $dt['activity'.$i] ;
		$t->set_var('activity_selectlist',str_replace("'$default'","'$default' selected",$act_sl)) ;
		$t->set_var('hour',$dt['hour'.$i]) ;
		$default = $dt['day'.$i] ;
		$t->set_var('day_selectlist',str_replace("'$default'","'$default' selected",$day_sl)) ;
		$t->set_var('achieve_selectlist',achieve_selectlist("",$dt['achieve'.$i],'short')) ;
		$t->set_var('achival',$dt['achival'.$i]) ;
		$t->set_var('achiunit',$dt['achiunit'.$i]) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('tsyear_fld','tsyear'.$i) ;
		$t->set_var('tsmonth_fld','tsmonth'.$i) ;
		$t->set_var('tsday_fld','tsday'.$i) ;
		$t->set_var('project_fld','project'.$i) ;
		$t->set_var('activity_fld','activity'.$i) ;
		$t->set_var('hour_fld','hour'.$i) ;
		$t->set_var('day_fld','day'.$i) ;
		$t->set_var('achieve_fld','achieve'.$i);
		$t->set_var('achival_fld','achival'.$i);
		$t->set_var('achiunit_fld','achiunit'.$i);
		$t->set_var('project_selectlist',$nullopt.project_selectlist('','','short')) ;
		$t->set_var('activity_selectlist',$act_sl) ;
		$t->set_var('hour','') ;
		$t->set_var('day_selectlist',$day_sl) ;
		$t->set_var('achieve_selectlist',achieve_selectlist("","",'short')) ;
		$t->set_var('achival','') ;
		$t->set_var('achiunit','') ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('hour_ttl',$dt[hour_ttl]) ;
	$t->set_var('day_ttl',$dt[day_ttl]) ;

	$t->parse('out','report',True);
	}

//---- Timesheet Post Initialisation

    function timesheet_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = "" ;
	}

//---- Timesheet Post - PreCommit Routine

    function timesheet_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	$empid = $dt[empid] ;
	if ($op<>'new')	$phpgw->db->query("DELETE from ${pre}ts_trans where trans_id='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['tsyear'.$i]);$i++) {
			$transdate= $dt['tsyear'.$i]."-".$dt['tsmonth'.$i]."-".$dt['tsday'.$i];
			$project	= ($dt['project'.$i]=="") ? 0 : $dt['project'.$i] ;
			$activity	= $dt['activity'.$i] ;
			$hour		= $dt['hour'.$i] ;
			$day		= $dt['day'.$i] ;
			$achieve	= $dt['achieve'.$i] ;
			$achival	= $dt['achival'.$i] ;
			$achiunit	= $dt['achiunit'.$i] ;
			$sql = "INSERT INTO ${pre}ts_trans " ;
			$sql.= "(trans_id,transdate,project,activity,hour,day,achieve,achival,achiunit) " ;
			$sql.= "VALUES ('$id','$transdate','$project','$activity'," ;
			$sql.= "'$hour','$day','$achieve','$achival','$achiunit')" ;
			$phpgw->db->query($sql);
			}
		}
	}

//---- Timesheet Post - PostCommit Routine

    function timesheet_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$lang_year = lang("YEAR") ;
	$lang_week = lang("WEEK") ;
	$inform = lang("Please manually inform") ;
	$year = $dt[year] ;
	$week = $dt[week] ;

	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$dt[empid]' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$superid' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$supername < $superemail >" ;
	$subject = "[$staffname] $lang_tran [$lang_year:$year $lang_week:$week] $actioned." ;
	if ($op<>'delete')   $subject.=' => '.lang('Please approve');
	$message = '' ;
	$headers = "From: $staffname < $staffemail >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $staffname < $staffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($op=='delete') {
		$successmsg = lang("Email advising action on timesheet successfully queued for despatch to") ;
		$failuremsg=lang("Email advising action on timesheet fails to deliver.")."  $inform";
		}
	  else  {
		$successmsg = lang("Email requesting timesheet approval successfully queued for despatch to");
		$failuremsg=lang("Email requesting timesheet approval fails to deliver.")."  $inform";
		}
	if ($result)	$msg = "<br>$successmsg $supername." ;
		else	$msg = "<br>$failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}


    }

?>
